// © Copyright The University of New South Wales 2018
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see http://www.gnu.org/licenses/.

#ifndef max_h
#define max_h

#include <pthread.h>

typedef struct listener {
    // POSIX thread - infinite listener
    pthread_t posixThreadID;
    int is_active;// = 0;   // true if the thread is running
} t_listener;

// robot_in (subscriber)
//int robin_close(char err_msg[]);

//int rin_open_twist(char rosSrvrIp[], void *obj, void (*f)(void*, void**), char err[]);
//int rin_open_twist2(char rosSrvrIp[], char *msg_type, void *obj, void (*f)(void*, void**), char err[]);
//int rin_open_chatter(char rosSrvrIp[], void *obj, void (*f)(void*, void**), char err[]);

//robot_out (publisher)
int rout_open_chatter(char rosSrvrIp[], char err_msg[]);
int rout_open_twist(char rosSrvrIp[], char err_msg[]);
int rout_close();
int rout_set();
int rout_set_twist(double out_msg[6]);

// Starts an infinite listening thread to recieve ROS messages.
//int launchthread(char err_msg[]);
//int killthread(char err_msg[]);
int robin_stop_listening(t_listener *listener, char *err_msg);
int robin_start_listening(t_listener *listener, char *err_msg);

int isValidIpAddressCheck(char *ipAddress);


//typedef struct geometry_msgs_Twist geometry_msgs_Twist;


#endif /* max_h */
